SystemOrganization addCategory: #'AL-Storage'!

Notification subclass: #ALStorageNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALStorageNotification subclass: #ALAddEntity
	instanceVariableNames: 'entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALAddEntity class methodsFor: 'signaling' stamp: 'cwp 11/24/2012 23:26'!
entity: anEntity
	^ (self withEntity: anEntity) signal! !

!ALAddEntity class methodsFor: 'instance creation' stamp: 'cwp 11/24/2012 23:26'!
withEntity: anEntity
	^ self basicNew initializeWithEntity: anEntity! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
entity
	^ entity! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:09'!
handleWith: anObject
	^ anObject handleAddEntity: self! !

!ALAddEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
initializeWithEntity: anEntity
	self initialize.
	entity := anEntity! !

ALStorageNotification subclass: #ALCollectEntities
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALCollectEntities class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:27'!
keys: aCollection
	^ (self withKeys: aCollection) signal! !

!ALCollectEntities class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
withKeys: aCollection
	^ self basicNew initializeWithKeys: aCollection! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:16'!
handleWith: anObject
	^ anObject handleCollectEntities: self! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
initializeWithKeys: aCollection
	self initialize.
	keys := aCollection! !

!ALCollectEntities methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:27'!
keys
	^ keys! !

ALStorageNotification subclass: #ALDeleteEntity
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALDeleteEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
key: aKey
	^ (self withKey: aKey) signal! !

!ALDeleteEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
withKey: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:09'!
handleWith: anObject
	^ anObject handleDeleteEntity: self! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:29'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALDeleteEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:28'!
key
	^ key! !

ALStorageNotification subclass: #ALEditEntity
	instanceVariableNames: 'key entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEditEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
key: aKey entity: anEntity
	^ (self withKey: aKey entity: anEntity) signal! !

!ALEditEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
withKey: aKey entity: anEntity
	^ self basicNew initializeWithKey: aKey entity: anEntity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
entity
	^ entity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:10'!
handleWith: anObject
	^ anObject handleEditEntity: anObject! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
initializeWithKey: aKey entity: anEntity
	self initialize.
	key := aKey.
	entity := anEntity! !

!ALEditEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:30'!
key
	^ key! !

ALStorageNotification subclass: #ALReadEntity
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALReadEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
key: aKey
	^ (self withKey: aKey) signal! !

!ALReadEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
withKey: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:10'!
handleWith: anObject
	^ anObject handleReadEntity: self! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:32'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALReadEntity methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:31'!
key
	^ key! !

ALRelay subclass: #ALStorageRelay
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALStorageRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:53'!
destination: aRelay repository: aRepository
	^ self basicNew initializeWithDestination: aRelay repository: aRepository! !

!ALStorageRelay methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 10:15'!
handleRequest: aRequest
	^ repository do: [ destination handleRequest: aRequest ]! !

!ALStorageRelay methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:54'!
initializeWithDestination: aRelay repository: aRepository
	self initializeWithDestination: aRelay.
	repository := aRepository! !

!ALStorageRelay methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:34'!
write: aMessage into: aWriteStream
	repository do: [ destination write: aMessage into: aWriteStream ]! !

Object subclass: #ALEntityReference
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALEntityReference class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:56'!
key: aKey
	^ self basicNew initializeWithKey: aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:48'!
= other
	^ self species = other species 
		and: [other hasKey: key]! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:04'!
hasKey: aKey
	^ key = aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:48'!
hash
	^ key hash! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 22:47'!
initializeWithKey: aKey
	self initialize.
	key := aKey! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:03'!
value
	^ ALReadEntity key: key! !

!ALEntityReference methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:04'!
value: anEntity
	ALEditEntity key: key value: anEntity.
	^ anEntity! !

Object subclass: #ALRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

ALRepository subclass: #ALMemoryRepository
	instanceVariableNames: 'entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Storage'!

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:20'!
add: anEntity
	| key |
	[key := (1 to: SmallInteger maxVal) atRandom.
	entities includesKey: key] 
		whileTrue.

	entities at: key put: anEntity.
	^ key! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:22'!
collect: keys
	^ keys collect: [:k | self read: k]! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:22'!
delete: key
	entities removeKey: key ifAbsent: []! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:23'!
edit: key value: anEntity
	entities at: key put: anEntity! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:06'!
initialize
	entities := Dictionary new! !

!ALMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:21'!
read: aKey
	^ entities at: aKey ifAbsent: [nil]! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:23'!
add: anEntity
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
collect: aCollection
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
delete: aKey
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:34'!
do: aBlock
	^ aBlock
		on: ALStorageNotification
		do: [ :n | n handleWith: self ]! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:24'!
edit: aKey value: anEntity
	self subclassResponsibility! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:28'!
handleAddEntity: aNotification
	| key |
	key := self add: aNotification entity.
	aNotification resume: key! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleCollectEntities: aNotification
	| entities |
	entities := self collect: aNotification keys.
	aNotification resume: entities! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleDeleteEntity: aNotification
	self delete: aNotification key.
	aNotification resume! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:29'!
handleEditEntity: aNotification
	self edit: aNotification key value: aNotification entity.
	aNotification resume! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2012 09:30'!
handleReadEntity: aNotification
	aNotification resume: (self read: aNotification key)! !

!ALRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/24/2012 23:25'!
read: aKey
	self subclassResponsibility! !
